// Written by Dr. YIP Chi Lap [Beta]
//   for Workshop on "Computer-aided visibility measurement using digital cameras",
//   Visibility Measurement Method Design Competition,
//   Faculty of Engineering, The University of Hong Kong, 2012.

void setup() {
  size(400,300);
}

void draw() {
  background(127);   // What is the background colour?

  /*
    Shapes like rectangles and ellipses can be drawn
      using their respective functions.
    For example, rect() draws rectangles.

    We need to specify what colour a rectangle is filled with,
      and the colour of the outline as well.

    fill() specifies the fill colour.
    The parameters are the same that for background().

    noFill() specifies that no filling is needed.

    stroke() specifies the stroke (outline) colour.
    The parameters are the same that for background().

    noStroke() specifies that no outline is needed.

  */

  fill(255,0,255);        // What is the fill colour?
  stroke(0);              // What is the colour of the outline?

  // The four parameters are x and y coordinates of the top left corner,
  //   width, and height of the rectangle.
  //
  // The semantics of the parameters can be changed by rectMode().
  //
  rect(50,100,200,100);

  noFill();               // Fill colour is changed.
                          // Note that we have not changed stroke colour
  rect(200,150,100,100);

  /*
     Note that opaque shapes drawn later in the program
       covers what has been drawn earlier.
  */
}
