// Written by Dr. YIP Chi Lap [Beta]
//   for Workshop on "Computer-aided visibility measurement using digital cameras",
//   Visibility Measurement Method Design Competition,
//   Faculty of Engineering, The University of Hong Kong, 2012.

/*
   Note that besides global variables like startX, startY, endX, and endY
     defined below that can be referenced anywhere,
     variables can be local to a function.

   That is, the variable can be accessed within a function
     after it is declared only.

   Local variables are useful for storing temporary values.

   There is a local variable in mouseReleased() below.
*/


int startX = -1;
int startY = -1;
int endX   = -1;
int endY   = -1;


void setup() {
  size(600,400);
}


void draw() {

  background(255,255,192);

  // Draw the rectangle
  rectMode(CORNERS);
  noFill();
  stroke(0);
  rect(startX, startY, endX, endY);

}


void mousePressed() {
  startX = mouseX;
  startY = mouseY;
  endX = mouseX;
  endY = mouseY;
}


void mouseDragged() {
  endX = mouseX;
  endY = mouseY;
}


void mouseReleased() {

  endX = mouseX;
  endY = mouseY;

  /*
     The variable named "area" is an integer because of the int before it.
     It is a local variable because it is defined within a function,
       which is mouseReleased() here.
  */
  int area = (endX-startX) * (endY-startY);

  // Print information about the rectangle in the message area
  println( "startX: " + startX + ", startY: " + startY +
           ", endX: " + endX + ", endY: " + endY );

  /* The local variable "area" is referenced here. */
  println("Area of rectangle = " + area);

}
