// Written by Dr. YIP Chi Lap [Beta]
//   for Workshop on "Computer-aided visibility measurement using digital cameras",
//   Visibility Measurement Method Design Competition,
//   Faculty of Engineering, The University of Hong Kong, 2012.

/*
   Answer to exercise:
   Draw light red (pink) grid lines
     that are 50 pixels from each other
     directly on the image.
   (RGB components of pink: R=255, G=192, B=192)

   => See the code after the image() call in the draw() function.
*/

PImage img;


void setup() {

  // load the image
  img = loadImage("imgHKW_100605_0900.jpg");

  // make window same size as that of image
  size(img.width, img.height);

}


void draw() {

  // use image as background
  background(img);

  /*
     We can draw the grid lines as in previous examples.
     Since they are drawn after the image is drawn,
       the grid lines can be seen covering the image itself.
  */

  // Let's make the grid lines light red (pink) in colour.
  stroke(255,192,192);

  for (int x=0; x<width; x+=50) {
    line(x,0,x,height);
  }

  for (int y=0; y<height; y+=50) {
    line(0,y,width,y);
  }
}
