// Written by Dr. YIP Chi Lap [Beta]
//   for Workshop on "Computer-aided visibility measurement using digital cameras",
//   Visibility Measurement Method Design Competition,
//   Faculty of Engineering, The University of Hong Kong, 2012.

PImage img;


void setup() {

  // Load the image
  img = loadImage("imgHKW_100605_0900.jpg");

  // Here, we make the window to be of the same size as the image.
  size(img.width, img.height);

}


void draw() {

  // Use image as background
  background(img);

  /*
     To indicate that the pixels of the window are to be accessed,
       loadPixels() must be called first.

     Afterwards, the pixels array can be used to
       get the value of an individual pixel.

     To find out the colour of a pixel at (x,y), use pixels[y*img.width+x].

     The pixels[] deference returns an object of type color .

     The colour value needs to be decoded using
       red(), green(), blue() to get the RGB values,
       or brightness() to get the brightness value.
  */

  // Prepare for accessing colour of a pixel
  loadPixels();

  // Here, p becomes the colour of the pixel of the picture at (50,100)
  // Note that p is a local variable whose type is color .
  color p = pixels[100*img.width + 50];

  // Print out the component and brightness values
  println("red: " + red(p) +
          ", green: " + green(p) +
          ", blue: " + blue(p) +
	  ", brightness: " + brightness(p));
}

/*
   Note that the current program always prints the RGB and brightness values
     of the pixel at (50,100).

   Exercise:
   1. Comment out (disable) the code for printing pixel values in draw() .
   2. Add a function to the program so that the RGB and brightness values
        of the pixel under the mouse cursor are printed out.
*/
