// Written by Dr. YIP Chi Lap [Beta]
//   for Workshop on "Computer-aided visibility measurement using digital cameras",
//   Visibility Measurement Method Design Competition,
//   Faculty of Engineering, The University of Hong Kong, 2012.

/*
   Answer to Exercise:
   1. Comment out (disable) the code for printing pixel values in draw() .

      => The easiest way is to use slash-asterisk ... asterisk-slash
           style to enclose the code to be commented out.

   2. Add a function to the program so that the RGB and brightness values
        of the pixel under the mouse cursor are printed out.

      => See the mouseMoved() function
*/


PImage img;


void setup() {

  // Load the image
  img = loadImage("imgHKW_100605_0900.jpg");

  // Here, we make the window to be of the same size as the image.
  size(img.width, img.height);

}


void draw() {

  // Use image img as background
  background(img);

  /*
     To indicate that the pixels of the window are to be accessed,
       loadPixels() must be called first.

     Afterwards, the pixels array can be used to
       get the value of an individual pixel.

     To find out the colour of a pixel at (x,y), use pixels[y*img.width+x].

     The pixels[] deference returns an object of type color .

     The colour value needs to be decoded using
       red(), green(), blue() to get the RGB values,
       or brightness() to get the brightness value.
  */

  /* This is used to comment out (disable) the unwanted code

  // Prepare for accessing colour of a pixel
  loadPixels();

  // Here, p becomes the colour of the pixel of the picture at (50,100)
  color p = pixels[100*img.width + 50];

  // Print out the component and brightness values
  println("red: " + red(p) +
          ", green: " + green(p) +
          ", blue: " + blue(p) +
	  ", brightness: " + brightness(p));
  */
}

void mouseMoved() {
  // Prepare for accessing colour of a pixel
  loadPixels();

  // Note very carefully the difference between the modified code below
  //   this and the disabled code in draw()
  // Here, p becomes the colour of the pixel of the picture at (mouseX,mouseY)
  //
  color p = pixels[mouseY*img.width + mouseX];

  // Print out the component and brightness values
  println("red: " + red(p) +
          ", green: " + green(p) +
          ", blue: " + blue(p) +
	  ", brightness: " + brightness(p));
}
