// Written by Dr. YIP Chi Lap [Beta]
//   for Workshop on "Computer-aided visibility measurement using digital cameras",
//   Visibility Measurement Method Design Competition,
//   Faculty of Engineering, The University of Hong Kong, 2012.

/*
   Answer to Exercise:
     Let the user define a rectange on the image.
     Nothing needs to be done after the rectangle is defined.
     Hint: integrate the code from a earlier exercise.
*/


// For loading image
PImage img;

/*
   These variables are for rectangle definition
*/
int startX = -1;
int startY = -1;
int endX   = -1;
int endY   = -1;


void setup() {

  // Load the image
  img = loadImage("imgHKW_100605_0900.jpg");

  // Make window size same as image size.
  size(img.width, img.height);

}


void draw() {
  // Use image img as background
  background(img);

  /*
     These are needed for the rectangle to be drawn
  */
  rectMode(CORNERS);
  noFill();
  stroke(0);
  rect(startX, startY, endX, endY);
}


void mouseMoved() {
  // Prepare for accessing colour of a pixel
  loadPixels();

  // Get the colour of the pixel of the picture at (mouseX,mouseY)
  color p = pixels[mouseY*img.width + mouseX];

  // Print out the component and brightness values
  println("red: " + red(p) +
          ", green: " + green(p) +
          ", blue: " + blue(p) +
	  ", brightness: " + brightness(p));
}


/*
   These are needed for user definition of a rectangle.
*/
void mousePressed() {
  startX = mouseX;
  startY = mouseY;
  endX = mouseX;
  endY = mouseY;
}

void mouseDragged() {
  endX = mouseX;
  endY = mouseY;
}

void mouseReleased() {
  endX = mouseX;
  endY = mouseY;
}


/*
   Exercise:
     Print out the average brightness of the image
       in the rectangular area marked by the user,
       when the mouse button is released.

     Hint 1. Define a variable named "sum" that is a floating point number this way:
               float sum  = 0.0;
     Hint 2. Loop over the pixels in the area to find the brightness values
               and accumulate them to the "sum" variable,
               and divide the sum by the area.
             You need a loop within another loop (nested loops) to do that.
*/
